// Copyright (C) Menhirs NV. All rights reserved.

#include "../StdAfx.h"
#include "cmdDbx.h"

#include "../dbx/MyEntity.h"

void cmdMyEntity()
{
    ads_point adsPoint;
	if (RTNORM != acedGetPoint(NULL,_T("\nInsertion point..."),adsPoint))
        return;

    const double r = 1.0;
    AcGePoint3d center = asPnt3d(adsPoint);
    AcGePoint3d point1(center.x - r,center.y,center.z);
    AcGePoint3d point2(center.x,center.y + r,center.z);
    AcGePoint3d point3(center.x + r,center.y,center.z);    

    AcDbDatabase* pDb = acdbHostApplicationServices()->workingDatabase();

    AcDbBlockTable* pBlockTable = NULL;
    pDb->getSymbolTable(pBlockTable, AcDb::kForRead);

    AcDbBlockTableRecord* pBlockTableRecord = NULL;
    pBlockTable->getAt(ACDB_MODEL_SPACE, pBlockTableRecord,AcDb::kForWrite);
    pBlockTable->close();

    CMyEntity* pMyEntity = new CMyEntity(point1, point2, point3);

    pMyEntity->setDatabaseDefaults(pDb);
    pBlockTableRecord->appendAcDbEntity(pMyEntity);
    pBlockTableRecord->close();

    pMyEntity->close();

#ifdef BRX_APP
    acutPrintf( _T("\nCustom entity added to the drawing. Please try grip edit on this entity.\nSee PropertiesPanel : entity properties + NoSelection properties are shown.") );
#else
    acutPrintf( _T("\nCustom entity added to the drawing. Please try grip edit on this entity.") );
#endif
}
