// Copyright (C) Menhirs NV. All rights reserved.

#include "StdAfx.h"
#include "cmdGui.h"

#include "../resource.h"
#include "../gui/MyDialogBar.h"

CMyDialogBar* s_pAppDialogBar = NULL;

void cmdDock()
{
    CAcModuleResourceOverride resSwitch;

    s_pAppDialogBar = new CMyDialogBar(); //instance is deleted in CMyDialogBar::PostNcDestroy

    BOOL isAutoDelete = s_pAppDialogBar->m_bAutoDelete;
    s_pAppDialogBar->m_bAutoDelete = FALSE;

    CMDIFrameWnd* pCadFrame = acedGetAcadFrame();
    pCadFrame->EnableDocking(CBRS_ALIGN_ANY);

    if (!s_pAppDialogBar->Create(pCadFrame, IDD_DIALOGBAR, CBRS_TOP | CBRS_GRIPPER, IDD_DIALOGBAR))
	{
        delete s_pAppDialogBar;
        acedAlert(ACRX_T("Failed to create a dockable dialog"));
		return;
	}

    s_pAppDialogBar->SetWindowText(ACRX_T("BRX Sample dockable dialog"));
	s_pAppDialogBar->EnableDocking(CBRS_ALIGN_ANY);

   	pCadFrame->DockControlBar(s_pAppDialogBar);
    pCadFrame->SetFocus();

    acutPrintf(_T("\nYou should now see a docked dialog at the top side."));
}