// Copyright (C) Menhirs NV. All rights reserved.

#pragma once

//This is an example of a custom entity based on AcDbEntity
//The entity represents a circle that is controlled by 3 points

class CMyEntity : public AcDbEntity
{
private:
    // stored in DWG
    AcGePoint3d m_point1;
    AcGePoint3d m_point2;
    AcGePoint3d m_point3;

public:
	ACRX_DECLARE_MEMBERS(CMyEntity);

public:
	CMyEntity();
    CMyEntity(const AcGePoint3d&,const AcGePoint3d&,const AcGePoint3d&);
	virtual ~CMyEntity() {};

    virtual Acad::ErrorStatus dwgOutFields(AcDbDwgFiler*) const;
    virtual Acad::ErrorStatus dwgInFields(AcDbDwgFiler*);
    virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler*) const;
    virtual Acad::ErrorStatus dxfInFields(AcDbDxfFiler*);

    virtual Adesk::Boolean subWorldDraw(AcGiWorldDraw*);

    virtual Acad::ErrorStatus subGetGripPoints(AcGePoint3dArray&,AcDbIntArray&,AcDbIntArray&) const;
    virtual Acad::ErrorStatus subMoveGripPointsAt(const AcDbIntArray&,const AcGeVector3d&);
    virtual Acad::ErrorStatus subGetOsnapPoints(AcDb::OsnapMode,Adesk::GsMarker,const AcGePoint3d&,const AcGePoint3d&,const AcGeMatrix3d&,AcGePoint3dArray&,AcDbIntArray&) const;
    virtual Acad::ErrorStatus subTransformBy(const AcGeMatrix3d&);
};

ACDB_REGISTER_OBJECT_ENTRY_AUTO(CMyEntity)
